﻿// Fill out your copyright notice in the Description page of Project Settings.

#pragma once

#include "CoreMinimal.h"
#include "UObject/Object.h"
#include "WorldState.h"
#include "GOAPAction.generated.h"

/**
 * 
 */
UCLASS()
class COMP250_1_2101327_AI_API UGOAPAction : public UObject
{
	GENERATED_BODY()

public:
	float ActionCost = 1.0f;
	FString ActionName;

	UFUNCTION()
	bool CheckPreConditions(UWorldState* WorldState);
	UFUNCTION()
	UWorldState* ApplyEffects(UWorldState* WorldState);
	UFUNCTION()
	virtual TMap<FString, int> Perform(UWorldState* WorldState);

	UPROPERTY()
	TMap<FString, int> PreConditions;
	UPROPERTY()
	TMap<FString, int> Effects;

	UFUNCTION()
	virtual void Init(){}
};
